/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefCommand A directive that a device must support to perform a certain function. A command may act upon a state, but does not necessarily act upon a state. For example, the ON command acts upon the ON/OFF state, but the GET command does not act upon any state, it simply gives a directive to retrieve a certain value. We propose here a list of commands that are relevant for the purpose of SAREF, but this list can be extended.
type SarefCommand interface {
	owl.Thing
	sarefActsUponMultipleSarefState
	sarefIsCommandOfMultipleSarefFunction
	sarefHasDescriptionSinglestring
	IsSarefCommand() bool // indicates base class
}

// sSarefCommand A directive that a device must support to perform a certain function. A command may act upon a state, but does not necessarily act upon a state. For example, the ON command acts upon the ON/OFF state, but the GET command does not act upon any state, it simply gives a directive to retrieve a certain value. We propose here a list of commands that are relevant for the purpose of SAREF, but this list can be extended.
type sSarefCommand struct {
	propCommon
	propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState
	propSarefIsCommandOfBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction
	propSarefHasDescriptionBasestringTypestringSinglestring
}

// NewSarefCommand creates a new SarefCommand
func (mod *Model) NewSarefCommand(iri string) (ret SarefCommand, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefCommand{}
	pc := propCommon{iri: iri, typ: "SarefCommand", model: mod}
	res.propCommon = pc
	mod.addSarefCommand(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefCommand) makeMaps() {
	res.sarefActsUpon = make(map[string]SarefState)
	res.sarefIsCommandOf = make(map[string]SarefFunction)
	return
}

// addSarefCommand adds SarefCommand to model
func (mod *Model) addSarefCommand(res SarefCommand) {
	mod.mSarefCommand[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefCommand returns all resources with given prefix
func (mod *Model) SarefCommand(prefix string) (res []SarefCommand) {
	for i := range mod.mSarefCommand {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefCommand[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefCommand) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#actsUpon":
		res.propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState.removeObject(obj)
	case "https://w3id.org/saref#isCommandOf":
		if v, ok := obj.(SarefFunction); ok {
			res.DelSarefIsCommandOf(v)
		}
	default:
	}
	return
}

// isSarefCommand indicates base class
func (res *sSarefCommand) IsSarefCommand() bool {
	return true
}

// SetSarefIsCommandOf is setter of A relationship between a command and a function.
func (res *sSarefCommand) SetSarefIsCommandOf(in []SarefFunction) (err error) {
	temp := res.sarefIsCommandOf
	res.sarefIsCommandOf = make(map[string]SarefFunction)
	for i := range temp {
		temp[i].DelSarefHasCommand(res)
	}
	err = res.AddSarefIsCommandOf(in...)
	return
}

// AddSarefIsCommandOf adds A relationship between a command and a function.
func (res *sSarefCommand) AddSarefIsCommandOf(in ...SarefFunction) (err error) {
	for i := range in {
		if _, ok := res.sarefIsCommandOf[in[i].IRI()]; !ok {
			res.sarefIsCommandOf[in[i].IRI()] = in[i]
			in[i].AddSarefHasCommand(res)
		}
	}
	return
}

// DelSarefIsCommandOf deletes A relationship between a command and a function.
func (res *sSarefCommand) DelSarefIsCommandOf(in ...SarefFunction) (err error) {
	for i := range in {
		if _, ok := res.sarefIsCommandOf[in[i].IRI()]; ok {
			delete(res.sarefIsCommandOf, in[i].IRI())
			in[i].DelSarefHasCommand(res)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefCommand) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefCommand) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#actsUpon":
		res.propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#isCommandOf":
		if obj, ok := res.model.mSarefFunction[pred.Object.Term.String()]; ok {
			res.AddSarefIsCommandOf(obj)
		}
	case "https://w3id.org/saref#hasDescription":
		res.propSarefHasDescriptionBasestringTypestringSinglestring.init(pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefCommand) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Command", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefCommand) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState.toGraph(node, g)
	res.propSarefIsCommandOfBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.toGraph(node, g)
	res.propSarefHasDescriptionBasestringTypestringSinglestring.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefCommand) String() (ret string) {
	ret = res.iri + " " + "SarefCommand\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefCommand) propsString() (ret string) {
	ret = ""
	ret += res.propSarefActsUponBaseSarefStateTypeSarefStateMultipleSarefState.String()
	ret += res.propSarefIsCommandOfBaseSarefFunctionTypeSarefFunctionMultipleSarefFunction.String()
	ret += res.propSarefHasDescriptionBasestringTypestringSinglestring.String()
	return
}


